#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include "gob-signal.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GobSignal * obj;


void
print_info_message(GtkWidget * window, gchar * message)
{
	GtkWidget * dialog;
	gchar * buffer;
	
	buffer = g_locale_to_utf8(message, strlen(message), NULL, NULL, NULL);
	dialog = gtk_message_dialog_new(window,
                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_CLOSE,
                                  buffer);
	 gtk_dialog_run (GTK_DIALOG (dialog));
	 gtk_widget_destroy (dialog); 
}

void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar * tmp;
	
	gob_signal_generate_signal(obj, TRUE);
	tmp = g_strdup_printf("Current obj->refcount = %i", G_OBJECT(obj)->ref_count);
	gtk_label_set_text(GTK_LABEL(lookup_widget(button, "label3")), tmp);
	g_free(tmp);
}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar * tmp;
	gob_signal_generate_signal(obj, FALSE);
	tmp = g_strdup_printf("Current obj->refcount = %i", G_OBJECT(obj)->ref_count);
	gtk_label_set_text(GTK_LABEL(lookup_widget(button, "label3")), tmp);
	g_free(tmp);
}

void 
on_signal_with_unref(GobSignal * gobobj, gpointer user_data)
{
	gchar * tmp = g_strdup_printf("In signal with unref : obj->refcount = %i", G_OBJECT(gobobj)->ref_count);
	print_info_message(GTK_WIDGET(user_data), tmp);
	g_free(tmp);
}

void 
on_signal_without_unref(GobSignal * gobobj, gpointer user_data)
{
	gchar * tmp = g_strdup_printf("In signal without unref : obj->refcount = %i", G_OBJECT(gobobj)->ref_count);
	print_info_message(GTK_WIDGET(user_data), tmp);
	g_free(tmp);
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar * tmp;
	
	if (!obj) obj = gob_signal_new();
	gob_signal_connect__signal_with_unref(obj, on_signal_with_unref, lookup_widget(button, "window1"));
	gob_signal_connect__signal_without_unref(obj, on_signal_without_unref, lookup_widget(button, "window1"));
	tmp = g_strdup_printf("Current  obj->refcount = %i", G_OBJECT(obj)->ref_count);
	gtk_label_set_text(GTK_LABEL(lookup_widget(button, "label3")), tmp);
	g_free(tmp);
}

